package backend

import (
	"golang.org/x/net/context"
)

type Cacher interface {
	CacheProperties(ctx context.Context, userID string, prop interface{}) error
	GetProperties(ctx context.Context, userID string) (interface{}, bool)
	CacheStringProperties(ctx context.Context, key string, prop string) error
	GetStringProperties(ctx context.Context, key string) (string, bool)
}
