// Code generated by mockery v1.0.0
package mocks

import (
	config "code.justin.tv/insights/piper-service/internal/config"
	context "golang.org/x/net/context"

	mock "github.com/stretchr/testify/mock"

	models "code.justin.tv/insights/piper-service/models"

	time "time"
)

// Backend is an autogenerated mock type for the Backend type
type Backend struct {
	mock.Mock
}

// AddProfileImageToResp provides a mock function with given fields: ctx, resp
func (_m *Backend) AddProfileImageToResp(ctx context.Context, resp *models.GameOnePagerDataResponse) error {
	ret := _m.Called(ctx, resp)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.GameOnePagerDataResponse) error); ok {
		r0 = rf(ctx, resp)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ConvertYearQuarterToStartDate provides a mock function with given fields: ctx, yearStr, quarterStr
func (_m *Backend) ConvertYearQuarterToStartDate(ctx context.Context, yearStr string, quarterStr string) (time.Time, error) {
	ret := _m.Called(ctx, yearStr, quarterStr)

	var r0 time.Time
	if rf, ok := ret.Get(0).(func(context.Context, string, string) time.Time); ok {
		r0 = rf(ctx, yearStr, quarterStr)
	} else {
		r0 = ret.Get(0).(time.Time)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, string, string) error); ok {
		r1 = rf(ctx, yearStr, quarterStr)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetDefaultQuarterStartRange provides a mock function with given fields: ctx
func (_m *Backend) GetDefaultQuarterStartRange(ctx context.Context) (models.QuarterStartRange, error) {
	ret := _m.Called(ctx)

	var r0 models.QuarterStartRange
	if rf, ok := ret.Get(0).(func(context.Context) models.QuarterStartRange); ok {
		r0 = rf(ctx)
	} else {
		r0 = ret.Get(0).(models.QuarterStartRange)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context) error); ok {
		r1 = rf(ctx)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetGameOnePager provides a mock function with given fields: ctx, gameID, yearStr, quarterStr
func (_m *Backend) GetGameOnePager(ctx context.Context, gameID string, yearStr string, quarterStr string) (models.GameOnePagerDataResponse, error) {
	ret := _m.Called(ctx, gameID, yearStr, quarterStr)

	var r0 models.GameOnePagerDataResponse
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string) models.GameOnePagerDataResponse); ok {
		r0 = rf(ctx, gameID, yearStr, quarterStr)
	} else {
		r0 = ret.Get(0).(models.GameOnePagerDataResponse)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, string, string, string) error); ok {
		r1 = rf(ctx, gameID, yearStr, quarterStr)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetGameOnePagerDownloadURL provides a mock function with given fields: ctx, gameID, yearStr, quarterStr, conf
func (_m *Backend) GetGameOnePagerDownloadURL(ctx context.Context, gameID string, yearStr string, quarterStr string, conf config.PiperConfig) (interface{}, string, error) {
	ret := _m.Called(ctx, gameID, yearStr, quarterStr, conf)

	var r0 interface{}
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string, config.PiperConfig) interface{}); ok {
		r0 = rf(ctx, gameID, yearStr, quarterStr, conf)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(interface{})
		}
	}

	var r1 string
	if rf, ok := ret.Get(1).(func(context.Context, string, string, string, config.PiperConfig) string); ok {
		r1 = rf(ctx, gameID, yearStr, quarterStr, conf)
	} else {
		r1 = ret.Get(1).(string)
	}

	var r2 error
	if rf, ok := ret.Get(2).(func(context.Context, string, string, string, config.PiperConfig) error); ok {
		r2 = rf(ctx, gameID, yearStr, quarterStr, conf)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// GetQuarterStartRange provides a mock function with given fields: ctx, gameID
func (_m *Backend) GetQuarterStartRange(ctx context.Context, gameID string) (models.QuarterStartRange, error) {
	ret := _m.Called(ctx, gameID)

	var r0 models.QuarterStartRange
	if rf, ok := ret.Get(0).(func(context.Context, string) models.QuarterStartRange); ok {
		r0 = rf(ctx, gameID)
	} else {
		r0 = ret.Get(0).(models.QuarterStartRange)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, gameID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// TrackOnePagerUsage provides a mock function with given fields: ctx, gamesEvent
func (_m *Backend) TrackOnePagerUsage(ctx context.Context, gamesEvent models.SpadeEvent) {
	_m.Called(ctx, gamesEvent)
}

// UserCanAccess provides a mock function with given fields: ctx, userID, gameID, companyID
func (_m *Backend) UserCanAccess(ctx context.Context, userID string, gameID string, companyID string) (bool, error) {
	ret := _m.Called(ctx, userID, gameID, companyID)

	var r0 bool
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string) bool); ok {
		r0 = rf(ctx, userID, gameID, companyID)
	} else {
		r0 = ret.Get(0).(bool)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, string, string, string) error); ok {
		r1 = rf(ctx, userID, gameID, companyID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}
