# New AMI

The latest devtools images install codedeploy via an in house package called `dta-codedeploy-agent`. this runs `codedeploy-agent` as `dtadeploy` user which does not have root privileges. Our piper codedeploy requires root privileges. So, we have to create an image that removes this package so when our new instance is provisioned it can install codedeploy using AWS's recommended script that runs codedeploy agent as the root user.

Provising the image

1. `cd twitch-service-piper-dev/ami`
1. `terraform apply`. note the ip out
1. `../../provision_image.sh <IP>`
1. Go into AWS console, find the new instance created.
1. Copy the AMI it's created from.
1. Right click > Instance > Create Image. Name the image `piper-DATE` such as `piper-O22119`. Make the description the AMI of the instance (copied from earlier).
1. Wait for the image to be created.

Testing the new image

1. Verify the image works by using [`test-instance`](../terraform/test-instance).
1. `terraform destroy`

Updating staging

1. Update `ami` in `terraform/twitch-service-piper-dev`.
1. terraform plan and apply.
1. Go through Updating Workers from Common Steps below.
1. Go through Updating Master from Common Steps below.
1. Upon success, share the image with our production account. To image, right click > Modify Image Permissions > Account Number: 452744562037 > Save

Updating production

1. Update `ami` in `terraform/twitch-service-piper-aws`.
1. terraform plan and apply.
1. Go through Updating Workers from Common Steps below.
1. Go through Updating Master from Common Steps below.

Done!

## Common Steps

### Updating Workers

1. increase the worker ASG by 1 and make sure the new instance is deployed to successfully.
1. double the desired size of the worker ASG. wait for them to come up.
1. reduce the size of the ASG back to the size it was.

### Updating Master

1. delete current master instance. ASG will create another one.